<template>
  <portal-page class="q-px-lg">
    <div class="row q-gutter-lg">
      <div class="col flex justify-between">
        <p
          v-if="
            (jobseekerStore.selectedRoomID == null && screenWidth <= 767) ||
            (jobseekerStore.selectedRoomID !== null && screenWidth >= 768) ||
            jobseekerStore.selectedRoomID == null
          "
          class="title-msg title-medium flex items-base justify-between"
          :style="{ width: screenWidth <= 767 ? '100%' : 'auto' }"
        >
          Messages

          <span
            v-if="jobseekerStore.selectedRoomID == null && screenWidth <= 767"
            style="font-size: 12px; color: #9b9b9b"
            >{{ jobseekerStore.rooms.length }} JOBS</span
          >
        </p>
        <q-btn
          v-if="jobseekerStore.selectedRoomID != null && screenWidth <= 767"
          unelevated
          text
          label="BACK"
          class="q-pa-none btn-back q-my-lg"
          icon="eva-arrow-back"
          @click="jobseekerStore.selectedRoomID = null"
        />
        <q-btn
          align="right"
          v-if="jobseekerStore.selectedRoomID != null && screenWidth <= 1023"
          unelevated
          text
          class="q-pa-none btn-back q-my-lg"
          icon="eva-alert-circle-outline"
          label="View info"
          style="color: #174c76"
          @click="showMobileDetail = true"
        />
      </div>
    </div>

    <div class="row q-gutter-xl">
      <div
        v-show="
          (jobseekerStore.selectedRoomID === null && screenWidth <= 767) ||
          (jobseekerStore.selectedRoomID !== null && screenWidth >= 768) ||
          jobseekerStore.selectedRoomID == null
        "
        :class="{
          col: screenWidth <= 767,
          'col-3': screenWidth >= 1024,
          'col-4': screenWidth >= 768 && screenWidth <= 1023,
        }"
      >
        <q-card
          flat
          class="msger-chat rounded-borders-10"
          style="bottom: 10px; position: sticky"
          :style="{
            'background-color': screenWidth <= 767 ? 'transparent' : '#fff',
          }"
        >
          <q-card-section
            :style="{ padding: screenWidth <= 767 ? '20px 0px' : '20px' }"
          >
            <div class="row">
              <div
                v-if="jobseekerStore.roomsLoading"
                class="col q-mt-lg"
                align="center"
              >
                <q-spinner color="primary" size="40px" :thickness="3" />
              </div>
              <div
                v-else-if="
                  jobseekerStore.roomsLoading === false &&
                  jobseekerStore.rooms.length > 0
                "
                class="col"
              >
                <!-- <q-infinite-scroll @load="fetchRooms" :offset="10"> -->
                <q-card
                  flat
                  class="q-pa-md q-mb-md rounded-borders-10 cursor-pointer"
                  v-for="(room, key) in jobseekerStore.rooms"
                  :key="key"
                  @click="fetchMessages(room, isUnread(room.latest_message))"
                  :style="{
                    'background-color': screenWidth <= 767 ? '#fff' : '#F5F5F5',
                  }"
                  :class="
                    room.id === jobseekerStore.selectedRoomID
                      ? 'card-room-selected'
                      : 'card-room'
                  "
                >
                  <div class="row">
                    <div
                      class="col-2 q-my-auto"
                      align="left"
                      :style="{
                        width:
                          screenWidth >= 768 && screenWidth <= 899
                            ? '28px'
                            : '48px',
                        height:
                          screenWidth >= 768 && screenWidth <= 899
                            ? '28px'
                            : '48px',
                      }"
                    >
                      <!-- <q-avatar color="positive">
                        <span class="title-headline text-white">{{
                          room.room_name.slice(0, 1)
                        }}</span>
                      </q-avatar> -->

                      <custom-avatar
                        :photoUrl="room.employer_picture_url"
                        :name="room.room_name"
                        userType="employer"
                        fontSize="17px"
                        :style="{
                          fontSize:
                            screenWidth >= 768 && screenWidth <= 899
                              ? '28px'
                              : '48px',
                        }"
                        shadow="shadow-5"
                      />
                    </div>

                    <div
                      class="q-my-auto q-pl-sm"
                      :class="screenWidth <= 767 ? 'col-7' : 'col'"
                    >
                      <div
                        class="msg-info-name"
                        :style="
                          isUnread(room.latest_message)
                            ? 'font-weight: 700'
                            : 'font-weight: 500'
                        "
                      >
                        {{ trim(getRoomName(room)) }}
                      </div>
                      <div
                        class="msg-info-details text-grey"
                        :style="
                          isUnread(room.latest_message)
                            ? 'font-weight: 800'
                            : ''
                        "
                      >
                        {{
                          room.latest_message !== null
                            ? trim(room.latest_message.message)
                            : ""
                        }}
                      </div>
                      <div
                        class="msg-info-details"
                        style="font-weight: 800"
                        :style="{
                          color: `${statusColor(
                            room.application.application_status.name
                          )}`,
                        }"
                      >
                        {{ room.application.application_status.name }}
                      </div>
                    </div>

                    <div class="col-2 q-mr-sm" align="right">
                      <span class="msg-info-details text-grey">
                        {{
                          room.latest_message !== null
                            ? formatDate(room.latest_message.created_at)
                            : formatDate(room.updated_at)
                        }}
                      </span>

                      <q-badge
                        v-if="isUnread(room.latest_message)"
                        class="q-ml-sm"
                        color="negative"
                        rounded
                      />
                    </div>
                  </div>
                </q-card>

                <InfiniteLoading @infinite="fetchRooms">
                  <template #spinner>
                    <div class="row justify-center q-my-md">
                      <q-spinner color="primary" size="40px" :thickness="3" />
                    </div>
                  </template>
                  <template #complete>
                    <div></div>
                  </template>
                </InfiniteLoading>
                <!-- <template v-slot:loading>
                    <div class="row justify-center q-my-md">
                      <q-spinner color="primary" size="40px" :thickness="3" />
                    </div>
                  </template>
                </q-infinite-scroll> -->
              </div>
              <div
                v-else
                class="col q-mt-lg"
                style="font-size: 16px"
                align="center"
              >
                <q-img
                  class="q-mt-md"
                  width="50%"
                  src="~assets/chat_message.svg"
                />
                <p class="q-ma-xl">
                  No messages yet. Submit an application to start a
                  conversation.
                </p>
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>

      <div
        v-show="jobseekerStore.selectedRoomID !== null"
        class="col"
        style="margin-left: 30px; margin-top: 25px"
      >
        <q-card
          flat
          class="bg-transparent"
          style="height: 80vh"
          v-show="jobseekerStore.selectedRoomID !== null"
        >
          <section class="msger">
            <div class="chat-header">
              <span
                class="q-ml-lg"
                style="font-weight: 700; font-size: 15px; color: #1d1d1d"
              >
                {{ jobseekerStore.selectedRoomName }}
              </span>
            </div>
            <main
              ref="containerMessageDisplay"
              class="msger-chat"
              style="padding: 10px 0 10px 0"
            >
              <div
                v-if="jobseekerStore.messageLoading"
                class="col q-mt-lg"
                align="center"
              >
                <q-spinner color="primary" size="40px" :thickness="3" />
              </div>
              <div
                v-else
                v-for="(message, key) in jobseekerStore.room"
                :key="key"
              >
                <div
                  :class="
                    message.user_id === userID
                      ? 'msg right-msg'
                      : 'msg left-msg'
                  "
                >
                  <div class="msg-bubble">
                    <div v-html="linkify(message.message)" />
                  </div>
                </div>
              </div>
            </main>

            <div class="row msger-inputarea">
              <div class="col-12">
                <q-editor
                  ref="textEditor"
                  v-model.trim="form.message"
                  @update:model-value="messageDidUpdate()"
                  min-height="2rem"
                  min-width="100%"
                  :dense="screenWidth <= 767"
                  :toolbar="[]"
                  placeholder="Enter your message here..."
                  @keydown.enter.prevent="sendMessage(form)"
                />

                <!-- :toolbar="[
                    ['bold', 'italic', 'strike', 'underline'],
                    ['link'],
                    [
                      {
                        label: $q.lang.editor.align,
                        icon: $q.iconSet.editor.align,
                        fixedLabel: true,
                        list: 'only-icons',
                        options: ['left', 'center', 'right', 'justify'],
                      },
                    ],
                    ['unordered', 'ordered', 'outdent', 'indent'],
                  ]" -->

                <!-- <q-spacer /> -->

                <div class="row" style="padding: 0 10px 10px 0">
                  <div class="col-10" align="left">
                    <span
                      class="text-negative text-left"
                      style="font-size: 12px; font-weight: 600"
                    >
                      {{ errorMessage }}
                    </span>
                  </div>

                  <div class="col-2" align="right">
                    <q-btn
                      unelevated
                      label="SEND"
                      class="btn--shade-2 btn-md text-white"
                      @click="sendMessage(form)"
                      style="width: 80%"
                      :loading="loading"
                    />
                  </div>
                </div>
              </div>
              <div
                class="confirm-container"
                v-if="
                  (applicationForm.application_status ===
                    '1st Interview Pending' &&
                    form.status.length == 0 &&
                    applicationStore.application.first_interview_status ===
                      null) ||
                  (applicationForm.application_status ===
                    '2nd Interview Pending' &&
                    form.status.length == 0 &&
                    applicationStore.application.second_interview_status ===
                      null)
                "
              >
                <div class="col" align="center">
                  <q-btn
                    unelevated
                    label="CONFIRM"
                    class="btn--shade-2 btn-md text-white q-mr-lg"
                    @click="confirmMessage(form)"
                    :loading="confirmLoading"
                  />

                  <q-btn
                    unelevated
                    label="REJECT"
                    color="negative"
                    class="btn-md"
                    @click="rejectMessage(form)"
                    :loading="rejectLoading"
                  />
                </div>
              </div>
            </div>
          </section>
        </q-card>
      </div>

      <div class="col-3" v-if="screenWidth >= 1024">
        <q-card
          flat
          class="msger-chat rounded-borders-10"
          style="bottom: 10px; position: sticky"
          v-if="
            jobseekerStore.selectedRoomID !== null &&
            applicationForm.id &&
            jobForm.id
          "
        >
          <!-- v-if="applicationForm.id && jobForm.id" -->
          <q-card-section class="q-pa-md">
            <span class="title-xsmall text-grey">APPLICATION STATUS</span>
            <div class="row q-my-md">
              <div class="col">
                <div
                  style="
                    height: 40px;
                    display: flex;
                    align-items: center;
                    padding: 10px;
                    font-weight: 800;
                    font-size: 15px;
                    border-radius: 10px;
                  "
                  :style="{
                    color: `${statusColor(applicationForm.application_status)}`,
                    background: `${statusBackgroundColor(
                      applicationForm.application_status
                    )}`,
                  }"
                >
                  {{ applicationForm.application_status }}
                </div>
              </div>
            </div>

            <div class="row q-my-md">
              <!-- <div class="col q-mr-md"> -->
              <q-btn
                unelevated
                label="VIEW CV / RESUME"
                style="width: 100%"
                class="btn--shade-2 btn-md text-white"
                @click="openFile(userStore.userDetails.cv_or_resume_url)"
              />
              <!-- </div> -->

              <!-- <div class="col">
                <q-btn
                  unelevated
                  style="width: 100%"
                  label="VIEW COVER LETTER"
                  class="btn--shade-2 btn-md text-white"
                />
              </div> -->
            </div>
          </q-card-section>

          <q-card-section>
            <span class="title-xsmall text-grey">ABOUT THE JOB</span>
            <div class="row q-pt-lg q-gutter-md">
              <!-- <q-avatar rounded color="positive" size="60px">
                <span class="title-headline text-white">{{
                  jobForm.company_name.slice(0, 1)
                }}</span>
              </q-avatar> -->

              <custom-avatar
                :photoUrl="jobseekerStore.selectedRoom.employer_picture_url"
                :name="jobForm.company_name"
                userType="employer"
                fontSize="17px"
                size="60px"
                :circle="false"
              />
              <div>
                <span
                  class="text-weight-bold"
                  style="font-size: 17px; color: #1d1d1d"
                >
                  {{ jobForm.job_title }}
                </span>
                <p style="font-size: 15px">{{ jobForm.company_name }}</p>
              </div>
            </div>

            <div
              class="row q-pt-lg"
              v-show="
                jobForm.full_time === true ||
                jobForm.part_time === true ||
                jobForm.freelance_or_contract === true ||
                jobForm.entry_level === true ||
                jobForm.intermediate === true ||
                jobForm.expert === true ||
                jobForm.on_site === true ||
                jobForm.remote === true ||
                jobForm.hybrid === true ||
                jobForm.years_of_experience >= 1 ||
                jobForm.vacancy_number >= 1
              "
            >
              <div class="col q-gutter-md">
                <!-- TAGS FOR JOB TYPE -->
                <q-badge
                  v-if="jobForm.full_time === true"
                  class="badge"
                  color="white"
                  label="FULL-TIME"
                />
                <q-badge
                  v-if="jobForm.part_time === true"
                  class="badge"
                  color="white"
                  label="PART-TIME"
                />
                <q-badge
                  v-if="jobForm.freelance_or_contract === true"
                  class="badge"
                  color="white"
                  label="FREELANCE/CONTRACT"
                />

                <!-- TAGS FOR EXPERIENCE LEVEL -->
                <q-badge
                  v-if="jobForm.entry_level === true"
                  class="badge"
                  color="white"
                  label="ENTRY LEVEL"
                />
                <q-badge
                  v-if="jobForm.intermediate === true"
                  class="badge"
                  color="white"
                  label="INTERMEDIATE"
                />
                <q-badge
                  v-if="jobForm.expert === true"
                  class="badge"
                  color="white"
                  label="EXPERT"
                />

                <!-- TAGS FOR OTHERS -->
                <q-badge
                  v-if="jobForm.on_site === true"
                  class="badge"
                  color="white"
                  label="ON-SITE"
                />
                <q-badge
                  v-if="jobForm.remote === true"
                  class="badge"
                  color="white"
                  label="REMOTE"
                />
                <q-badge
                  v-if="jobForm.hybrid === true"
                  class="badge"
                  color="white"
                  label="HYBRID"
                />

                <q-badge
                  v-if="jobForm.years_of_experience >= 1"
                  class="badge"
                  color="white"
                >
                  {{
                    jobForm.years_of_experience === 1
                      ? jobForm.years_of_experience + " YEAR EXPERIENCE"
                      : jobForm.years_of_experience + " YEARS EXPERIENCE"
                  }}
                </q-badge>
                <q-badge
                  v-if="jobForm.vacancy_number >= 1"
                  class="badge"
                  color="white"
                >
                  {{
                    jobForm.vacancy_number === 1
                      ? jobForm.vacancy_number + " VACANCY"
                      : jobForm.vacancy_number + " VACANCIES"
                  }}
                </q-badge>
              </div>
            </div>

            <div class="row q-mt-lg">
              <div class="col">
                <span class="title-6" v-html="jobForm.job_description"></span>
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>
    </div>
  </portal-page>

  <!-- DIALOG -->
  <q-dialog
    v-model="showMobileDetail"
    persistent
    @hide="showMobileDetail === false"
  >
    <q-card
      flat
      class="msger-chat rounded-borders-10"
      style="bottom: 10px; position: sticky"
      v-if="
        jobseekerStore.selectedRoomID !== null &&
        applicationForm.id &&
        jobForm.id
      "
    >
      <q-card-section
        class="row items-center q-pb-sm"
        style="
          position: sticky;
          top: 0;
          left: 0;
          z-index: 2;
          background: #fff;
          border-bottom: 1px solid #ddd;
        "
      >
        <span class="title-headline text-dark">Company Info</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section class="q-pa-md">
        <span class="title-xsmall text-grey">APPLICATION STATUS</span>
        <div class="row q-my-md">
          <div class="col">
            <div
              style="
                height: 40px;
                display: flex;
                align-items: center;
                padding: 10px;
                font-weight: 800;
                font-size: 15px;
                border-radius: 10px;
              "
              :style="{
                color: `${statusColor(applicationForm.application_status)}`,
                background: `${statusBackgroundColor(
                  applicationForm.application_status
                )}`,
              }"
            >
              {{ applicationForm.application_status }}
            </div>
          </div>
        </div>

        <div class="row q-my-md">
          <!-- <div class="col q-mr-md"> -->
          <q-btn
            unelevated
            label="VIEW CV / RESUME"
            style="width: 100%"
            class="btn--shade-2 btn-md text-white"
            @click="openFile(userStore.userDetails.cv_or_resume_url)"
          />
          <!-- </div> -->

          <!-- <div class="col">
                <q-btn
                  unelevated
                  style="width: 100%"
                  label="VIEW COVER LETTER"
                  class="btn--shade-2 btn-md text-white"
                />
              </div> -->
        </div>
      </q-card-section>

      <q-card-section>
        <span class="title-xsmall text-grey">ABOUT THE JOB</span>
        <div class="row q-pt-lg q-gutter-md">
          <!-- <q-avatar rounded color="positive" size="60px">
                <span class="title-headline text-white">{{
                  jobForm.company_name.slice(0, 1)
                }}</span>
              </q-avatar> -->

          <custom-avatar
            :photoUrl="jobseekerStore.selectedRoom.employer_picture_url"
            :name="jobForm.company_name"
            userType="employer"
            fontSize="17px"
            size="60px"
            :circle="false"
          />
          <div>
            <span
              class="text-weight-bold"
              style="font-size: 17px; color: #1d1d1d"
            >
              {{ jobForm.job_title }}
            </span>
            <p style="font-size: 15px">{{ jobForm.company_name }}</p>
          </div>
        </div>

        <div
          class="row q-pt-lg"
          v-show="
            jobForm.full_time === true ||
            jobForm.part_time === true ||
            jobForm.freelance_or_contract === true ||
            jobForm.entry_level === true ||
            jobForm.intermediate === true ||
            jobForm.expert === true ||
            jobForm.on_site === true ||
            jobForm.remote === true ||
            jobForm.hybrid === true ||
            jobForm.years_of_experience >= 1 ||
            jobForm.vacancy_number >= 1
          "
        >
          <div class="col q-gutter-md">
            <!-- TAGS FOR JOB TYPE -->
            <q-badge
              v-if="jobForm.full_time === true"
              class="badge"
              color="white"
              label="FULL-TIME"
            />
            <q-badge
              v-if="jobForm.part_time === true"
              class="badge"
              color="white"
              label="PART-TIME"
            />
            <q-badge
              v-if="jobForm.freelance_or_contract === true"
              class="badge"
              color="white"
              label="FREELANCE/CONTRACT"
            />

            <!-- TAGS FOR EXPERIENCE LEVEL -->
            <q-badge
              v-if="jobForm.entry_level === true"
              class="badge"
              color="white"
              label="ENTRY LEVEL"
            />
            <q-badge
              v-if="jobForm.intermediate === true"
              class="badge"
              color="white"
              label="INTERMEDIATE"
            />
            <q-badge
              v-if="jobForm.expert === true"
              class="badge"
              color="white"
              label="EXPERT"
            />

            <!-- TAGS FOR OTHERS -->
            <q-badge
              v-if="jobForm.on_site === true"
              class="badge"
              color="white"
              label="ON-SITE"
            />
            <q-badge
              v-if="jobForm.remote === true"
              class="badge"
              color="white"
              label="REMOTE"
            />
            <q-badge
              v-if="jobForm.hybrid === true"
              class="badge"
              color="white"
              label="HYBRID"
            />

            <q-badge
              v-if="jobForm.years_of_experience >= 1"
              class="badge"
              color="white"
            >
              {{
                jobForm.years_of_experience === 1
                  ? jobForm.years_of_experience + " YEAR EXPERIENCE"
                  : jobForm.years_of_experience + " YEARS EXPERIENCE"
              }}
            </q-badge>
            <q-badge
              v-if="jobForm.vacancy_number >= 1"
              class="badge"
              color="white"
            >
              {{
                jobForm.vacancy_number === 1
                  ? jobForm.vacancy_number + " VACANCY"
                  : jobForm.vacancy_number + " VACANCIES"
              }}
            </q-badge>
          </div>
        </div>

        <div class="row q-mt-lg">
          <div class="col">
            <span class="title-6" v-html="jobForm.job_description"></span>
          </div>
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import PortalPage from "src/layouts/portals/PortalPage.vue";
import dayjs from "dayjs";
import { defineComponent, ref, reactive, watch } from "vue";
import { useRoom } from "../store/room";
import { useApplication } from "../store/application";
import { useUser } from "src/layouts/portals/store/user";
// import { useJob } from "../store/job";
import { JobseekerMessageApi } from "src/hooks/api";
import { pusher } from "boot/pusher";
import { LocalStorage } from "quasar";
import { onMounted, onUnmounted } from "vue";
import _ from "lodash";
import CustomAvatar from "src/components/CustomAvatar.vue";
import linkifyHtml from "linkify-html";
// const urlRegex = require("url-regex");
import InfiniteLoading from "v3-infinite-loading";
import "v3-infinite-loading/lib/style.css";

export default defineComponent({
  name: "MessagesPage",
  components: {
    PortalPage,
    CustomAvatar,
    InfiniteLoading,
  },

  setup() {
    const jobseekerStore = useRoom();
    const { getRooms, showRoom, addRoomMessage, updateRoomStatus, resetRooms } =
      jobseekerStore;

    const applicationStore = useApplication();
    const { showApplication, setApplicationDetail } = applicationStore;

    const screenWidth = ref(0);
    const userStore = useUser();
    const showMobileDetail = ref(false);

    onMounted(() => {
      console.log("Jobseeker onMounted");
      fetchData();
      // if (jobseekerStore.selectedRoomID != null) {
      //   fetchMessages(jobseekerStore.selectedRoom, false);
      // }
      // if (
      //   jobseekerStore.selectedRoomID != null &&
      //   applicationStore.selectedApplicationID != null
      // ) {
      //   fetchMessages(
      //     jobseekerStore.selectedRoomID,
      //     applicationStore.selectedApplicationID,
      //     false
      //   );
      // }

      let scrollDiv = containerMessageDisplay.value;
      scrollDiv.addEventListener("scroll", handleScroll);
      window.addEventListener("resize", screenResize);
    });

    onUnmounted(() => {
      console.log("Jobseeker onUnmounted");
      window.removeEventListener("resize", screenResize);
      // pusher.connection.unbind_all();
    });

    // const jobStore = useJob();
    // const { getJobs, showJob } = jobStore;

    const loading = ref(false);
    const confirmLoading = ref(false);
    const rejectLoading = ref(false);
    const isError = ref(false);
    const errorMessage = ref("");
    const isConfirmedOrRejected = ref(true);
    const userID = LocalStorage.getItem("auth").id;
    const containerMessageDisplay = ref(null);
    const textEditor = ref(null);
    const atBottom = ref(false);
    const sortBy = ref(1);

    const form = reactive({
      room_id: null,
      message: "",
      status: "",
    });

    const applicationForm = reactive({
      id: null,
      application_status: null,
      cover_letter: null,
      cv_or_resume_url: null,
      job_post_id: null,
    });

    const linkOptions = {
      defaultProtocol: "https",
      tagName: "a",
      target: {
        url: "_blank",
      },
    };

    watch(
      () => _.cloneDeep(applicationForm),
      (currentValue, oldValue) => {
        if (currentValue.application_status) {
          if (
            currentValue.application_status != oldValue.application_status &&
            currentValue.id == oldValue.id
          ) {
            updateRoomStatus(currentValue.application_status);
          }
        }
      }
    );

    const jobForm = reactive({
      id: null,
      job_title: null,
      company_name: null,
      full_time: null,
      part_time: null,
      freelance_or_contract: null,
      entry_level: null,
      intermediate: null,
      expert: null,
      on_site: null,
      remote: null,
      hybrid: null,
      job_description: null,
      years_of_experience: null,
      vacancy_number: null,
    });

    const message = ref("");

    const fetchData = async () => {
      resetRooms();
      getRooms();
      pusherBind();
    };

    const pusherBind = () => {
      pusher.connection.bind("message", (msg) => {
        if (msg.event == "message") {
          console.log("event: message");
          console.log("message: ", msg);
          manageNewMessage(msg.data);
        }
      });
    };

    const manageNewMessage = async (message) => {
      if (message.data.user_id != userID) {
        if (message.data.room_id == jobseekerStore.selectedRoomID) {
          if (
            applicationStore.currentApplicationStatusID !=
            message.applicationStatusId
          ) {
            getApplication(applicationStore.selectedApplicationID);
          }

          addRoomMessage(message.data);
          setTimeout(() => {
            if (atBottom.value) {
              goToBottom(true);
            }
          }, 200);
        }
        // else {
        //   await getRooms();
        // }
      } else {
        addRoomMessage(message.data);
        setTimeout(() => {
          goToBottom(true);
        }, 200);
      }
    };

    const handleScroll = (e) => {
      let scrollDiv = containerMessageDisplay.value;
      atBottom.value =
        scrollDiv.scrollHeight - 100 <=
        e.target.scrollTop + scrollDiv.offsetHeight;
    };

    const isUnread = (message) => {
      if (message == null) return false;
      if (message.user_id != userID) {
        return message.read_at == null;
      }
      return false;
    };

    const statusColor = (status) => {
      switch (status) {
        case "Pending":
          return "#9E9E9E";
          break;
        case "1st Interview Pending":
          return "#FF9800";
          break;
        case "1st Interview Confirmed":
          return "#FFC107";
          break;
        case "2nd Interview Pending":
          return "#06A9F4";
          break;
        case "2nd Interview Confirmed":
          return "#009688";
          break;
        case "Hired":
          return "#4CAF50";
          break;
        case "Rejected":
          return "#F44336";
          break;
        default:
          return "#F0F0F0";
          break;
      }
    };

    const statusBackgroundColor = (status) => {
      switch (status) {
        case "Pending":
          return "#F5F5F5";
          break;
        case "1st Interview Pending":
          return "#FFF3E0";
          break;
        case "1st Interview Confirmed":
          return "#FFF8E1";
          break;
        case "2nd Interview Pending":
          return "#E1F5FE";
          break;
        case "2nd Interview Confirmed":
          return "#E0F2F1";
          break;
        case "Hired":
          return "#E8F5E9";
          break;
        case "Rejected":
          return "#FFEBEE";
          break;
        default:
          return "#F0F0F0";
          break;
      }
    };

    const goToBottom = (animated) => {
      let scrollDiv = containerMessageDisplay.value;
      scrollDiv.scrollTo({
        top: scrollDiv.scrollHeight,
        behavior: animated ? "smooth" : "instant",
      });
    };

    const openFile = (url) => {
      window.open(url);
    };

    const formatDate = (date) => {
      return dayjs(date).format("MMM-DD");
    };

    const fetchRooms = async ($state) => {
      console.log("isLoaded: ", jobseekerStore.isLoaded);
      // if (jobseekerStore.isLoaded) {
      //   done(true);
      //   return;
      // }

      await getRooms().then((data) => {
        console.log("data: ", data);
        // done();
        // setTimeout(() => {
        console.log("current_page: ", data.current_page);
        console.log("last_page: ", data.last_page);
        if (data.current_page != data.last_page) {
          // done();
          $state.loaded();
        } else {
          // done(true);
          $state.complete();
        }
        // }, 1000);
        // done(true);
      });
    };

    const fetchMessages = async (room, isUnread) => {
      form.room_id = room.id;
      form.message = "";
      form.status = "";
      errorMessage.value = "";

      // getApplication(application_id);
      setApplication(room.application);
      await showRoom(room.id, isUnread).then(() => {
        goToBottom(false);
      });
    };

    const setApplication = (application) => {
      setApplicationDetail(application);
      applicationForm.id = applicationStore.application.id;
      applicationForm.application_status =
        applicationStore.application.application_status.name;
      applicationForm.cover_letter = applicationStore.application.cover_letter;
      applicationForm.cv_or_resume_url =
        applicationStore.application.cv_or_resume_url;
      applicationForm.job_post_id = applicationStore.application.job_post_id;

      jobForm.id = applicationStore.application.job_post.id;
      jobForm.company_name = applicationStore.application.job_post.company_name;
      jobForm.job_title = applicationStore.application.job_post.job_title;
      jobForm.full_time = applicationStore.application.job_post.full_time;
      jobForm.part_time = applicationStore.application.job_post.part_time;
      jobForm.freelance_or_contract =
        applicationStore.application.job_post.freelance_or_contract;
      jobForm.entry_level = applicationStore.application.job_post.entry_level;
      jobForm.intermediate = applicationStore.application.job_post.intermediate;
      jobForm.expert = applicationStore.application.job_post.expert;
      jobForm.on_site = applicationStore.application.job_post.on_site;
      jobForm.remote = applicationStore.application.job_post.remote;
      jobForm.hybrid = applicationStore.application.job_post.hybrid;
      jobForm.job_description =
        applicationStore.application.job_post.job_description;
      jobForm.years_of_experience =
        applicationStore.application.job_post.years_of_experience;
      jobForm.vacancy_number =
        applicationStore.application.job_post.vacancy_number;
    };

    const getApplication = async (application_id) => {
      await showApplication(application_id).then((data) => {
        if (data.success) {
          // console.log("showApplication: ", data);
          if (form.status.length > 0) {
            form.status = "";
          }
          applicationForm.id = applicationStore.application.id;
          applicationForm.application_status =
            applicationStore.application.application_status.name;
          applicationForm.cover_letter =
            applicationStore.application.cover_letter;
          applicationForm.cv_or_resume_url =
            applicationStore.application.cv_or_resume_url;
          applicationForm.job_post_id =
            applicationStore.application.job_post_id;

          jobForm.id = applicationStore.application.job_post.id;
          jobForm.company_name =
            applicationStore.application.job_post.company_name;
          jobForm.job_title = applicationStore.application.job_post.job_title;
          jobForm.full_time = applicationStore.application.job_post.full_time;
          jobForm.part_time = applicationStore.application.job_post.part_time;
          jobForm.freelance_or_contract =
            applicationStore.application.job_post.freelance_or_contract;
          jobForm.entry_level =
            applicationStore.application.job_post.entry_level;
          jobForm.intermediate =
            applicationStore.application.job_post.intermediate;
          jobForm.expert = applicationStore.application.job_post.expert;
          jobForm.on_site = applicationStore.application.job_post.on_site;
          jobForm.remote = applicationStore.application.job_post.remote;
          jobForm.hybrid = applicationStore.application.job_post.hybrid;
          jobForm.job_description =
            applicationStore.application.job_post.job_description;
          jobForm.years_of_experience =
            applicationStore.application.job_post.years_of_experience;
          jobForm.vacancy_number =
            applicationStore.application.job_post.vacancy_number;
        }
      });
    };

    const sendMessage = async (payload) => {
      if (payload.message.length > 0) {
        loading.value = true;
        isError.value = false;
        errorMessage.value = "";

        await JobseekerMessageApi.create(payload)
          .then((response) => {
            // console.log("sendMessage: ", response);
            payload.message = "";
            if (response.data.success) {
              if (form.status == "Reject") {
                getApplication(applicationStore.selectedApplicationID);
              }

              if (form.status.length > 0) {
                getRooms();
              }
            }
          })
          .catch((error) => {
            isError.value = true;
            errorMessage.value = error?.response?.data?.message.toUpperCase();
          })
          .finally(() => {
            loading.value = false;
          });
      } else {
        errorMessage.value = "THE MESSAGE FIELD IS REQUIRED.";
      }
    };

    const confirmMessage = (payload) => {
      form.status = "Confirm";
      errorMessage.value = "YOU ARE REQUIRED TO LEAVE A NOTE TO THE EMPLOYER";
      textEditor.value.focus();
    };

    const rejectMessage = (payload) => {
      form.status = "Reject";
      errorMessage.value = "YOU ARE REQUIRED TO LEAVE A NOTE TO THE EMPLOYER";
      textEditor.value.focus();
    };

    const messageDidUpdate = () => {
      if (form.message.length > 0 && form.message != " ") {
        errorMessage.value = "";
      }
    };

    const trim = (message) => {
      return message.replaceAll("&nbsp;", "").replace(/<\/?[^>]+(>|$)/g, "");
    };

    const linkify = (message) => {
      let string = linkifyHtml(message, linkOptions);
      return string
        .replaceAll("&nbsp;", "")
        .replaceAll("<a ", '<a style="color: #8AB4F8" ');
      // .replace(urlRegex({ strict: false }), function (url) {
      //   return (
      //     '<a style="color: #8AB4F8" href="' +
      //     url +
      //     '" target="_blank">' +
      //     url +
      //     "</a>"
      //   );
      // });
    };

    const getRoomName = (room) => {
      return room.room_name + "(" + room.application.job_post.job_title + ")";
    };

    const screenResize = () => {
      screenWidth.value = window.innerWidth;
    };

    screenResize();

    const filterJobPosts = () => {};

    return {
      jobseekerStore,
      applicationStore,
      userStore,
      // jobStore,
      form,
      applicationForm,
      jobForm,
      message,
      userID,
      // USER_ID,
      loading,
      confirmLoading,
      rejectLoading,
      isError,
      isConfirmedOrRejected,
      errorMessage,
      fetchMessages,
      fetchRooms,
      sendMessage,
      confirmMessage,
      rejectMessage,
      openFile,
      formatDate,
      isUnread,
      containerMessageDisplay,
      textEditor,
      handleScroll,
      atBottom,
      statusColor,
      statusBackgroundColor,
      getApplication,
      messageDidUpdate,
      linkify,
      trim,
      getRoomName,
      sortOptions: [
        {
          label: "Most Recent",
          value: 1,
        },
        {
          label: "Job Title (A-Z)",
          value: 2,
        },
        {
          label: "Job Title (Z-A)",
          value: 3,
        },
        {
          label: "Company Name (A-Z)",
          value: 4,
        },
        {
          label: "Company Name (Z-A)",
          value: 5,
        },
      ],
      screenResize,
      screenWidth,
      showMobileDetail,
    };
  },
});
</script>

<style lang="scss" scoped>
:root {
  --body-bg: linear-gradient(135deg, #f5f7fa 0%, #c3cfe2 100%);
  --msger-bg: #fff;
  --border: 2px solid #ddd;
  --left-msg-bg: #ececec;
  --right-msg-bg: #579ffb;
}

html,
body {
  display: flex;
  justify-content: center;
  align-items: center;
  margin: 0;
  height: 100%;
  background-image: var(--body-bg);
  overflow: hidden;
}

.msger {
  display: flex;
  flex-flow: column wrap;
  justify-content: space-between;
  width: 100%;
  max-width: 867px;
  margin: 25px 10px;
  height: calc(100% - 50px);
  // background: var(--msger-bg);
  background: #f5f5f5;
  border-radius: 10px;
  overflow: hidden;
}

.chat-header {
  background: white;
  height: 55px;
  border-top-left-radius: 10px;
  border-top-right-radius: 10px;
  display: flex;
  align-items: center;
  -webkit-box-shadow: 0 10px 20px black;
  -moz-box-shadow: 0 10px 20px black;
  box-shadow: 0 -10px 20px black;
  z-index: 1;
}

.msger-chat {
  flex: 1;
  overflow-y: auto;
  height: 75vh !important;
}
.msger-chat::-webkit-scrollbar {
  width: 6px;
}
.msger-chat::-webkit-scrollbar-track {
  background: #ddd;
}
.msger-chat::-webkit-scrollbar-thumb {
  background: #bdbdbd;
}
.msger-chat::-webkit-scrollbar {
  display: none;
}
.msger-chat {
  -ms-overflow-style: none;
  scrollbar-width: none;
}
.msg {
  display: flex;
  align-items: flex-end;
  margin-bottom: 10px;
}
.msg:last-of-type {
  margin: 0;
}
.msg-img {
  width: 50px;
  height: 50px;
  margin-right: 10px;
  background: #ddd;
  background-repeat: no-repeat;
  background-position: center;
  background-size: cover;
  border-radius: 50%;
}
.msg-bubble {
  max-width: 450px;
  padding: 10px 15px 10px 15px;
  border-radius: 15px;
  background: #fff;
  margin: 5px 15px 5px 15px;
}
.msg-info {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: 10px;
}
.msg-info-name {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  margin-right: 10px;
  font-weight: 700;
  font-size: 15px;
  line-height: 20px;
}
.msg-info-details {
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  font-weight: 400;
  font-size: 11px;
  line-height: 15px;
}

.msg-info-time {
  font-size: 0.85em;
}

.left-msg .msg-bubble {
  border-bottom-left-radius: 0;
}

.right-msg {
  flex-direction: row-reverse;
}
.right-msg .msg-bubble {
  background: $dark-blue;
  border-bottom-right-radius: 0;
  color: white;
}
.right-msg .msg-img {
  margin: 0 0 0 10px;
}

.msg-actions {
  position: sticky;
  bottom: 10px;
}

.msger-inputarea {
  display: flex;
  // border-top: var(--border);
  // border-radius: 10px;
  background: white;
  position: sticky;
  position: relative;
  border-bottom-left-radius: 10px;
  border-bottom-right-radius: 10px;
  -webkit-box-shadow: 0 10px 20px black;
  -moz-box-shadow: 0 10px 20px black;
  box-shadow: 0 10px 20px black;
}
.msger-inputarea * {
  padding: 10px;
  border: none;
  // border-radius: 10px;
  // font-size: 1em;
}
.confirm-container {
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  left: 0;
  border-radius: 10px;
  background: rgba(255, 255, 255, 0.8);
  display: flex;
  justify-content: center;
  align-items: center;
}
.msger-input {
  flex: 1;
  background: #ddd;
}
.msger-send-btn {
  margin-left: 10px;
  background: rgb(0, 196, 65);
  color: #fff;
  font-weight: bold;
  cursor: pointer;
  transition: background 0.23s;
}
.msger-send-btn:hover {
  background: rgb(0, 180, 50);
}

.q-editor {
  // background: #f5f5f5;
  width: 100%;
  font-size: 15px;
}

#view {
  width: 180px !important;
}

.q-card__section--vert {
  padding: 20px;
}

.card-room {
  &:hover {
    background-color: #e8eef2 !important;
    // border: 1px solid #174c76;
    transition: ease 0.2s;
  }
}

.card-room-selected {
  background-color: #e8eef2 !important;
  border: 1px solid #174c76;
  transition: ease 0.2s;
}

.title-msg {
  color: $dark-blue !important;
  margin: 0 !important;
  padding-top: 35px !important;
  padding-bottom: 35px !important;
}
</style>
